
define(dir, Hetris)
define(dotdot, .)

define(makefile, dir/Makefile)

haskell_modules_program(dir, haskell_with_ffi_compiler -lcurses, dir)

dir/Curses.hs: dir/Curses.hsc makefile
	hsc2hs -o $@ $< -L -lcurses

dir/wrap.o: dir/wrap.c dir/wrap.h makefile
	gcc -Wall -pedantic -c $< -o $@

dir/Hetris: dir/wrap.h dir/wrap.o makefile

dir/Hetris.dvi: dir/Makefile dir/Haskell2LaTeX.sty dir/ifmtarg.sty makefile

dir/%.doclet.tex: dir/%.lhs dotdot/Haskell2LaTeX/Haskell2LaTeX makefile
	dotdot/Haskell2LaTeX/Haskell2LaTeX < $< > $@

dir/%.doclet.tex: dir/%.alhs dotdot/Haskell2LaTeX/Haskell2LaTeX makefile
	dotdot/Haskell2LaTeX/Haskell2LaTeX < $< > $@

dir/Hetris.tex: dir/Makefile $(filter-out dir/Hetris.tex, $(wildcard dir/*.tex)) $(patsubst %.lhs, %.doclet.tex, $(wildcard dir/*.lhs)) $(patsubst %.alhs, %.doclet.tex, $(wildcard dir/*.alhs)) makefile
	cat dir/{Header.tex,Title.tex,Intro.tex,Terminology.tex,Plan.tex,Data.doclet.tex,AbstractPieces.doclet.tex,Pieces.doclet.tex,AbstractBoard.doclet.tex,Board.doclet.tex,AbstractUI.doclet.tex,UI.doclet.tex,Input.doclet.tex,Output.doclet.tex,Hetris.doclet.tex,Conclusion.tex,Footer.tex} > $@

clean::
	rm -f dir/{Curses.hs,Hetris.tex,Hetris-pp.tex,Hetris,*.o,*.hi,*.doclet.tex,Hetris.{log,toc,aux,dvi,ps,pdf}}

