
SUBS:=BNF2Automaton PCLib Position Haskell2LaTeX automaton EpsOpt report Hetris
LHS_SUBS:=BNF2Automaton PCLib Position Haskell2LaTeX EpsOpt Hetris

.PHONY: default install clean distclean really-clean
.SECONDARY:

default: targets

install:
ifneq (,$(findstring Haskell2LaTeX/Haskell2LaTeX , targets ))
	mkdir -p prefix/bin
	cp Haskell2LaTeX/Haskell2LaTeX prefix/bin
endif
ifneq (,$(findstring report/report.ps , targets ))
	mkdir -p prefix/share/doc/Haskell2LaTeX
	cp report/report.ps prefix/share/doc/Haskell2LaTeX
endif
ifneq (,$(findstring Hetris/Hetris , targets ))
	mkdir -p prefix/bin
	cp Hetris/Hetris prefix/bin
endif
ifneq (,$(findstring Hetris/Hetris.ps , targets ))
	mkdir -p prefix/share/doc/Hetris
	cp Hetris/Hetris.ps prefix/share/doc/Hetris
endif

# Include the general Makefile stuff
include mk/General.Makefile
# Include the Makefilelets for all the components
include $(addsuffix /Makefile,$(SUBS))

dep:
	for SUB in $(LHS_SUBS); do ./gen_deps $$SUB; done
	$(MAKE) Haskell2LaTeX/IA.lhs
	./gen_deps Haskell2LaTeX

distclean: clean
	rm -f $(addsuffix /Makefile,$(SUBS)) Makefile

really-clean: distclean
	for SUB in $(LHS_SUBS); do echo -n > $$SUB/dependencies; done

