
changequote([, ])
define(dir, report)
define(dotdot, .)
define(makefile, dir/Makefile)

DIAGS:=$(shell for i in `seq 0 69`; do echo dir/diag$$i; done)
DIAGS_EPS_GZ:=$(addsuffix .eps.gz,$(DIAGS))
DIAGS_EPS_BB:=$(addsuffix .eps.bb,$(DIAGS))
DIAGS_LOUT:=$(addsuffix .lout,$(DIAGS))

dir/report.tex: dir/report.lhs dotdot/Haskell2LaTeX/Haskell2LaTeX makefile
	dotdot/Haskell2LaTeX/Haskell2LaTeX dir/report.lhs > dir/report.tex

$(DIAGS_LOUT): dotdot/BNF2Automaton/BNF2Automaton dotdot/automaton/description makefile
	dotdot/BNF2Automaton/BNF2Automaton --diags -o dir -p diag < dotdot/automaton/description

dir/%.eps.bb: dir/%.eps.gz makefile
	zgrep "^%%BoundingBox: " $< > $@

#dir/%.eps: dir/%.lout dotdot/EpsOpt/EpsOpt makefile
#	lout $< -o $@
#	dotdot/EpsOpt/EpsOpt $@ +RTS -K2M
#	mv $@.opt $@

dir/%.eps: dir/%.lout dotdot/EpsOpt/EpsOpt makefile
	lout $< -o $@.unopt
	dotdot/EpsOpt/EpsOpt $@.unopt -o $@ +RTS -K2M
	rm $@.unopt

dir/report.dvi: $(DIAGS_EPS_GZ) $(DIAGS_EPS_BB) dir/seq.eps.bb dir/seq.eps.gz dir/report.bib dir/report.bst dir/example.sty dir/Haskell2LaTeX.sty dir/bbding.sty dir/bbding10.mf dir/example.sty dir/ifmtarg.sty dir/lambdaTeX-igl.sty dir/newcrest.mf dir/newcrestletters.mf dir/*.inc makefile

# Cancel built-in rule for dvi -> tex so make uses ours
%.dvi: %.tex

clean::
	rm -f dir/*.{aux,log,bbl,blg,dvi,toc,lof,eps.gz,eps.bb}
	rm -f dir/diag*.lout dir/report.{tex,dvi,ps,pdf}
	rm -f dir/{newcrest.600pk,newcrest.log,newcrest.tfm}
	rm -f dir/{bbding10.tfm,bbding10.600pk}
	rm -f dir/*.unopt

